<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateBucketUsersTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('bucket_users', function (Blueprint $table)
        {
            // Primary key.
            $table->uuid('id')->primary();

            // Foreign key for hub
            $table->uuid('bucket_id');

            // Foreign key for user
            $table->uuid('user_id');

            // Foreign key for user
            $table->uuid('role_id');

            $table->foreign('bucket_id')->references('id')->on('buckets');
            $table->foreign('user_id')->references('id')->on('users');
            $table->foreign('role_id')->references('id')->on('roles');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('bucket_users');
    }
}
